| Travis Linux build status| AppVeyor Windows build status | CII Best Practices | Documentation |
|--------------------------|-------------------------------|--------------------|---------------|
|[![Build Status](https://travis-ci.org/Ifsttar/I-Simpa.svg?branch=master)](https://travis-ci.org/Ifsttar/I-Simpa)| [![Build Status](https://ci.appveyor.com/api/projects/status/github/Ifsttar/I-Simpa?svg=true)](https://ci.appveyor.com/project/nicolas-f/I-Simpa)| [![CII Best Practices](https://bestpractices.coreinfrastructure.org/projects/3005/badge)](https://bestpractices.coreinfrastructure.org/projects/3005)| [![Documentation Status](https://readthedocs.org/projects/i-simpa-wiki/badge/?version=latest)](https://i-simpa-wiki.readthedocs.io/fr/latest/?badge=latest)|


<IMG SRC="https://github.com/Ifsttar/I-Simpa/blob/master/Docs/images/I-Simpa-logo.jpg" WIDTH=400 ALT="I-Simpa logo" TITLE="I-Simpa logo">|



* **For general information**, [visit the offical I-Simpa website](https://i-simpa.univ-gustave-eiffel.fr/)
* **For using I-Simpa**, see [the Online User Guide](http://i-simpa-wiki.readthedocs.io/fr/latest/)
* **For build instructions**, see [the instructions](https://github.com/Ifsttar/I-Simpa/blob/master/Docs/Building.md)
* **For contributing to I-Simpa**, see [the GitHub wiki](https://github.com/Ifsttar/I-Simpa/wiki/)
* **Follow us on Twitter** <a href="https://twitter.com/intent/follow?screen_name=ISimpaOfficial">
        <img src="https://img.shields.io/twitter/follow/ISimpaOfficial.svg?style=social&logo=twitter"
            alt="follow on Twitter"></a>

## Description

<IMG ALIGN="right" SRC="https://github.com/Ifsttar/I-Simpa/blob/fa9a49791a0359f4ced45bbc31edc8e581eeddd0/Docs/images/Illustrations/illustration_I_Simpa_room.png" WIDTH=350 ALT="Room illustration" TITLE="Room illustration">

I-Simpa is a graphical user interface (GUI) developed to host three-dimensional numerical codes for the modeling of sound propagation in complex geometrical domains. Although I-Simpa is well adapted for energetic models (ray-tracing, sound-particle tracing, theory of reverberation…), it can be extend to use ondulatory approaches.

I-Simpa alone is not a calculation software, but is equivalent to a pre and post-processor for acoustic codes. One or more numerical codes must be added in order to obtain a fully functional system. At the present time, I-Simpa is delivered with two codes (TCR and SPPS, see information here).

Classical applications are room and building acoustics, environmental noise and industrial noise, but it can be easily extend to other applications concerning the sound propagation in 3D environments (interior of vehicle, sound in cavities…).

The main concepts of I-Simpa are:

* a functional GUI: elements and components are organized in tree structures, to easily access to all information, parameters and
properties. Many features are proposed for helping users…
* an ‘open’ system: all information and data are organized in spreadsheets that can be displayed, exported, copied…
* an ‘open’ software: each user can integrate its own numerical propagation code, develop its own functionalities within the interface
for its own applications… All have been done in order you can extend I-Simpa easily.


I-Simpa has been initially developed as a research tool (i.e. for research laboratories), but can also be a very efficient tool for a professional or commercial use.

## Developments

I-Simpa is developped by the [Environmental Acoustic Research unit](http://www.umrae.fr/en/) ([Université Gustave Eiffel](https://www.univ-gustave-eiffel.fr/en/) (formely Ifsttar, formerly LCPC)

## **License for users**

I-Simpa is an application developped by Ifsttar under the GENERAL PUBLIC LICENSE Version 3, please refere to [GPLv3](https://github.com/Ifsttar/I-Simpa/blob/master/LICENSE.md) for more details about it and [here](https://github.com/Ifsttar/I-Simpa/blob/master/Docs/License.txt) for Ifsttar information.

## **License Agreement for contributors**

For legal reasons, contributors are asked to agree with a Contributor License Agreement (for Individual or for Entity). Contributors will be added in the 'About' dialog box of I-Simpa. For more information visit the following page: https://i-simpa.univ-gustave-eiffel.fr/community/contribute/contribute-to-the-code/
